/**
@todo
CC֐gȂRpC̏ꍇ͈ȉ̂悤ȋKŏĂ݂ĂB
@code
#define dkcMTRand64_real3_base(func,p) \
	( ((func(p) >> 12) + 0.5) * (1.0/4503599627370496.0) );

#define dkcMTRand64_real3(p) dkcMTRand64_real3_base(dkcMTRand64Get,p)
@endcode
*/

#ifndef DKUTIL_C_MT_RAND64_H
#define DKUTIL_C_MT_RAND64_H


#include <dkutil_c/dkc_misc.h>
#include <stdio.h>

#define dkcdMT_RAND64_NN 312
typedef struct dkc_Mersenne_Twister_64bit{
	/** The array for the state vector */
	uint64 mt[dkcdMT_RAND64_NN]; 
	int mti; 
	struct dkc_Mersenne_Twister_64bit *basep;
}DKC_MT_RAND64;

DKC_EXTERN DKC_MT_RAND64 *WINAPI dkcAllocMTRand64(uint64 seed);

DKC_EXTERN int WINAPI dkcFreeMTRand64(DKC_MT_RAND64 **p);



DKC_EXTERN void WINAPI dkcMTRand64Init(DKC_MT_RAND64 *p,uint64 seed);

DKC_EXTERN void WINAPI 
	dkcMTRand64InitByArray(DKC_MT_RAND64 *p,uint64 *init_key,uint64 key_length);


DKC_EXTERN uint64 WINAPI dkcMTRand64Get(DKC_MT_RAND64 *p);



/** generates a random number on [0, 2^63-1]-interval */
DKC_INLINE int64 dkcMTRand64_Get63(DKC_MT_RAND64 *p)
{
    return (int64)(dkcMTRand64Get(p) >> 1);
}

/** generates a random number on [0,1]-real-interval */
DKC_INLINE double dkcMTRand64_real1(DKC_MT_RAND64 *p)
{
    return (dkcMTRand64Get(p) >> 11) * (1.0/9007199254740991.0);
}

/** generates a random number on [0,1)-real-interval */
DKC_INLINE double dkcMTRand64_real2(DKC_MT_RAND64 *p)
{
    return (dkcMTRand64Get(p) >> 11) * (1.0/9007199254740992.0);
}

/** generates a random number on (0,1)-real-interval */
DKC_INLINE double dkcMTRand64_real3(DKC_MT_RAND64 *p)
{
    return ((dkcMTRand64Get(p) >> 12) + 0.5) * (1.0/4503599627370496.0);
}

typedef struct {
	DKC_MT_RAND64 *ptr;
	uint64 cache[dkcdMT_RAND64_NN];
}DKC_MT_RAND64_CACHE;

DKC_EXTERN void WINAPI dkcMTRand64CacheNext(DKC_MT_RAND64_CACHE *p);


DKC_EXTERN DKC_MT_RAND64_CACHE *WINAPI dkcAllocMTRand64Cache(uint64 seed);

DKC_EXTERN int WINAPI dkcFreeMTRand64Cache(DKC_MT_RAND64_CACHE *a);

#define dkcMTRand64CacheGet(p) \
	( ( (p->ptr->mti >= dkcdMT_RAND64_NN) ? dkcMTRand64CacheNext(p),0:0) ,\
	 p->cache[p->ptr->mti++] )


#define dkcMTRand64CacheInit(p,seed) dkcMTRand64Init(p->ptr,seed)

#define dkcMTRand64CacheInitByArray(p,init_key,key_length) dkcMTRand64InitByArray(p->ptr,init_key,key_length)

/** generates a random number on [0, 2^63-1]-interval */
DKC_INLINE int64 dkcMTRand64Cache_Get63(DKC_MT_RAND64_CACHE *p)
{
    return (int64)(dkcMTRand64CacheGet(p) >> 1);
}

/** generates a random number on [0,1]-real-interval */
DKC_INLINE double dkcMTRand64Cache_real1(DKC_MT_RAND64_CACHE *p)
{
    return (dkcMTRand64CacheGet(p) >> 11) * (1.0/9007199254740991.0);
}

/** generates a random number on [0,1)-real-interval */
DKC_INLINE double dkcMTRand64Cache_real2(DKC_MT_RAND64_CACHE *p)
{
    return (dkcMTRand64CacheGet(p) >> 11) * (1.0/9007199254740992.0);
}

/** generates a random number on (0,1)-real-interval */
DKC_INLINE double dkcMTRand64Cache_real3(DKC_MT_RAND64_CACHE *p)
{
    return ((dkcMTRand64CacheGet(p) >> 12) + 0.5) * (1.0/4503599627370496.0);
}

#endif



